// Code generated by mockery v2.42.3. DO NOT EDIT.

package mocks

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
)

// MockParser is an autogenerated mock type for the Parser type
type MockParser struct {
	mock.Mock
}

type MockParser_Expecter struct {
	mock *mock.Mock
}

func (_m *MockParser) EXPECT() *MockParser_Expecter {
	return &MockParser_Expecter{mock: &_m.Mock}
}

// ParseQuery provides a mock function with given fields: ctx, query
func (_m *MockParser) ParseQuery(ctx context.Context, query string) ([]string, error) {
	ret := _m.Called(ctx, query)

	if len(ret) == 0 {
		panic("no return value specified for ParseQuery")
	}

	var r0 []string
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) ([]string, error)); ok {
		return rf(ctx, query)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) []string); ok {
		r0 = rf(ctx, query)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]string)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, query)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// MockParser_ParseQuery_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ParseQuery'
type MockParser_ParseQuery_Call struct {
	*mock.Call
}

// ParseQuery is a helper method to define mock.On call
//   - ctx context.Context
//   - query string
func (_e *MockParser_Expecter) ParseQuery(ctx interface{}, query interface{}) *MockParser_ParseQuery_Call {
	return &MockParser_ParseQuery_Call{Call: _e.mock.On("ParseQuery", ctx, query)}
}

func (_c *MockParser_ParseQuery_Call) Run(run func(ctx context.Context, query string)) *MockParser_ParseQuery_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string))
	})
	return _c
}

func (_c *MockParser_ParseQuery_Call) Return(_a0 []string, _a1 error) *MockParser_ParseQuery_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

func (_c *MockParser_ParseQuery_Call) RunAndReturn(run func(context.Context, string) ([]string, error)) *MockParser_ParseQuery_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockParser creates a new instance of MockParser. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockParser(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockParser {
	mock := &MockParser{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
